#!/usr/bin/php
<?php
require_once '/usr/local/esia/plugins/lib/CacheFile.class.php';
//require_once '/home/tareq/mount/vsrv-dev-tareq-enterprise/plugins/lib/CacheFile.class.php';

$DEFAULT_TIMEOUT = 50;
$STR_STATUS=array("OK","WARNING","CRITICAL","UNKNOWN");
$INT_STATUS=array_flip($STR_STATUS);
//$CACHEDIRECTORY = '/usr/local/esia/public_html/plugin/website/check_qualys/qualys/';
$CACHEDIRECTORY = '/tmp/qualys/';
$short_opts="hu:w:c:";
$long_opts=array("help","url:","warning:","critical:");

$options=getopt($short_opts,$long_opts);




function print_usage($bad_usage){
        echo 'USAGE : '.basename($_SERVER['PHP_SELF'])." -u <URL> -w <WARN> -c <CRITIC> [-t <TIMEOUT>]\n";
        if($bad_usage) echo 'HELP  : '.basename($_SERVER['PHP_SELF'])." -h\n";
}

function print_help(){
        $col=20;
        print_usage(false);
        echo "\n";
        echo "Check the current number of established TCP connections\n\n";
        echo "\t-u, ".str_pad("--url=URL",$col)               ."Domain name\n";
//        echo "\t-t, ".str_pad("--timeout=SECONDES",$col)        ."Timeout in seconds\n";
        echo "\t-w, ".str_pad("--warning=INTEGER",$col)         ."Max tolerated temperature for warning\n";
        echo "\t-c, ".str_pad("--critical=INTEGER",$col)        ."Max tolerated temperature for critical\n";
        echo "\n";
        echo "\t-h, ".str_pad("--help",$col)                    ."Print this help\n";
        echo "\n";
}


function exit_state($state,$msg=null,$usage=false){
        $STR_STATUS=$GLOBALS["STR_STATUS"];
        $INT_STATUS=$GLOBALS["INT_STATUS"];

        $ret=$state;
        if( is_string($state) ) $ret=$INT_STATUS[strtoupper($state)];
        else $state=$STR_STATUS[$ret];

        if( $msg != null ) echo "$state - $msg\n";
        if( $usage ) print_usage(true);
        exit($ret);
}

function getParam($name1,$name2,$default=null){
        global $options;

        if( isset( $options[$name1] ) ) return $options[$name1];
        if( isset( $options[$name2] ) ) return $options[$name2];
        return $default;
}

function calcul_state($a,$b=null){
	$STR_STATUS=$GLOBALS["STR_STATUS"];
	$INT_STATUS=$GLOBALS["INT_STATUS"];
	$PRIORITIES_STATES=$GLOBALS["PRIORITIES_STATES"];

	if(is_string($a) ) $a=$INT_STATUS[strtoupper($a)];
	if(is_string($b) ) $b=$INT_STATUS[strtoupper($b)];

	foreach($PRIORITIES_STATES as $value){
		$value = $INT_STATUS[$value];

		if( $value == $a || $value == $b ) return $value;
	}
	return $INT_STATUS["UNKNOWN"];
}

//traitement

$url = getParam("u","url");
$timeout = getParam("t","timeout",$DEFAULT_TIMEOUT);
$warning = getParam("w","warning",60);
$critical = getParam("c","critical",70);


if ( isset($options["help"]) || isset($options["h"]) ){
        print_help();
        exit($INT_STATUS["UNKNOWN"]);
}

/*
$all_state = NULL ; 
foreach ($data as $actual_state){
    $all_state = calcul_state($actual_state,$all_state);
    $str.= "$all_state / CPU :  $actual_state" ;
}
*/
if(empty($url))
{
    exit_state("UNKNOWN","The url has not been communicated",TRUE);
}
if( $warning == null ) exit_state(3,"You forget to specify warning.",true);
if( $critical == null ) exit_state(3,"You forget to specify critical.",true);


$url_iframe = $url ;

////
if( is_dir($CACHEDIRECTORY) == FALSE)
{
    if(mkdir($CACHEDIRECTORY,0755)==FALSE)
    {
        echo "Can't create direcotry cache\n";
        exit($ERROR['UNKNOWN']);        
    }
}

//$url_iframe =preg_replace('#^-H\s+\W\w+#',,$url_iframe);
//preg_match('#[a-zA-Z]+\s[a-zA-Z]+\s+[0-9]+\s[0-9\:]+\s[0-9]+\s\+[0-9]+#',$url_iframe,$matches);

preg_match('#www\.[0-9a-zA-Z\-]+\.[a-zA-Z]+#',$url_iframe,$url_iframe_matches);

$filepath= "$CACHEDIRECTORY$url_iframe_matches[0].txt";
$file = new CacheFile($filepath,120);
//chmod("$filepath", 0755);

$data = array();
if($file->isValid())
{
//    echo "CACHE_FILE: VALID"."\n";
    $data = json_decode($file->getData());

    if(($data->{'grade'}=="A") || ($data->{'grade'}=="A+") || ($data->{'grade'}=="A-"))
    {
	    //$grade_state = "OK";
        exit_state("OK","The associated Overall Rating is : ".$data->{'grade'},FALSE);
    }
    elseif(($data->{'grade'}=="B") || ($data->{'grade'}=="C"))
    {
	    //$grade_state = "WARNING";
        exit_state("WARNING","The associated Overall Rating is : ".$data->{'grade'},FALSE);
    }
    else
    {
	    //$grade_state = "CRITICAL";
        exit_state("CRITICAL","The associated Overall Rating is : ".$data->{'grade'},FALSE);
    }
}
else
{ 
    $homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
    $homepage = json_decode($homepage,true);
    if((!isset($homepage['endpoints'][0]['grade'])))
    {
        //echo "OK: Grade evaluate, test is running\n";
        exit_state("OK","Grade evaluate, test is running",FALSE);
    }
    if((!isset($homepage['endpoints'][0]['details']['certChains'][0]['trustPaths'])))
    {
    
        //echo "OK: Grade evaluate, test is running\n";
        exit_state("OK","Grade evaluate, test is running",FALSE);
    }
    if((!isset($homepage['endpoints'][0]['details']['certChains'][0]['issues'])))
    {
    
        //echo "OK: Grade evaluate, test is running\n";
        exit_state("OK","Grade evaluate, test is running",FALSE);
    }
    $grade = $homepage['endpoints'][0]['grade'];
    $trusted = $homepage['endpoints'][0]['details']['certChains'][0]['trustPaths'];
    $Chain_issues = $homepage['endpoints'][0]['details']['certChains'][0]['issues'];
/*
    $grade = $homepage['endpoints'][0]['grade'];
    $trusted = $homepage['endpoints'][0]['details']['certChains'][0]['trustPaths'];
    // $B2 = $homepage[endpoints][0][details][certChains][0][trustPaths][0][trust][0][isTrusted];
    $Chain_issues = $homepage['endpoints'][0]['details']['certChains'][0]['issues'];
    $i= 0;
    while(!isset($homepage['endpoints'][0]['grade'])&& $i < 120 )
    {
	    $homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	    $homepage = json_decode($homepage,true);
	    // $grade = $homepage['endpoints'][0]['grade'];
        sleep(1);
	    $i++;
    }
    $grade = $homepage['endpoints'][0]['grade'];

    while(!isset($homepage['endpoints'][0]['details']['certChains'][0]['trustPaths']))
    {
	    $homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	    $homepage = json_decode($homepage,true);
	    
	    //$trusted = $homepage['endpoints'][0]['details']['certChains'][0]['trustPaths'];
    }
    $trusted = $homepage['endpoints'][0]['details']['certChains'][0]['trustPaths'];

    while(!isset($homepage['endpoints'][0]['details']['certChains'][0]['issues']))
    {
	    $homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	    $homepage = json_decode($homepage,true);
		    // 	$B2 = $homepage[endpoints][0][details][certChains][0][trustPaths][0][trust][0][isTrusted];
	    //$Chain_issues = $homepage['endpoints'][0]['details']['certChains'][0]['issues'];
    }
    $Chain_issues = $homepage['endpoints'][0]['details']['certChains'][0]['issues'];
*/
    $count=0;
    $isTrusted = "No";
    $isTrusted_values = array();
    foreach ($trusted as $value)
    {
	    if($value['trust'][0]['isTrusted'] != 0)
	    {
		    $isTrusted = "Yes";
            if($count != 0)
            {
		        if($isTrusted_values[$count-1]!=$value['trust'][0]['rootStore'])
		        {
			        $isTrusted_values[$count] = $value['trust'][0]['rootStore'];
			        $count++;
		        }
            }
            else
            {
                $isTrusted_values[$count] = $value['trust'][0]['rootStore'];
			    $count++;
            }
	    }
    }

    $tmp = $isTrusted_values;
    $c = $isTrusted_values[0];
    for ($i = 1; $i <= count($isTrusted_values)-1; $i++) {
	    $c=$c."-".$isTrusted_values[$i];
    }
    $isTrusted_values = $c;

    switch($Chain_issues)
    {
	    case 0:
		    $Chain_issues = "None";
		    break;
	    case 2:
		    $Chain_issues = "incomplete";
		    break;
	    case 4:
		    $Chain_issues = "unrelated";
		    break;
	    case 8:
		    $Chain_issues = "order incorrect";
		    break;
	    case 16:
		    $Chain_issues = "self-signed";
		    break;
	    case 32:
		    $Chain_issues = "not validate";
		    break;
    }

    $data = array('grade'=>$grade,'trusted'=>$isTrusted,'trusted_value'=>$isTrusted_values,'chain'=> $Chain_issues);
//    echo  "CACHE_FILE: NOT VALID"."\n";
    $file->writeData(json_encode($data));

    if(($data['grade']=="A") || ($data['grade']=="A+") || ($data['grade']=="A-"))
    {
	    //$grade_state = "OK";
        exit_state("OK","The associated Overall Rating is : ".$data['grade'],FALSE);
    }
    elseif(($data['grade']=="B") || ($data['grade']=="C"))
    {
	    //$grade_state = "WARNING";
        exit_state("WARNING","The associated Overall Rating is : ".$data['grade'],FALSE);
    // $data[\'trusted\'] $data[\'chain\']
    }
    else
    {
	    //$grade_state = "CRITICAL";
        exit_state("CRITICAL","The associated Overall Rating is : ".$data['grade'],FALSE);
    }
}





/*
////
$filepath= "/home/tareq/Bureau/qualys/$url_iframe.txt";
$file = new CacheFile($filepath,$during=120);

echo $filepath ;
echo "ok2";


if($file->isValid())
{
    echo "CACHE_FILE: VALID";
    $data = $file->getData();
}
else
{ 
    $text = file_get_content('/home/tareq/Bureau/test.txt');
    echo  "CACHE_FILE: NOT VALID";
    $file->writeData($grade);
}

echo "ok4";
////
*/


/*
// colors :

if(($grade=="A") || ($grade=="A+") || ($grade=="A-"))
{
	$gradeColor = "#83bc00";
}
elseif(($grade=="B") || ($grade=="C"))
{
	$gradeColor = "#ffcb1f";
}
else
{
	$gradeColor = "#da002e";
}

if($isTrusted=="No")
{
	$trustedColor = "#da002e";
}
else
{
	$trustedColor = "#83bc00";
}

if($Chain_issues=="None")
{
	$ChainissuesColor = "#222222";
}
elseif (($Chain_issues=="incomplete") || ($Chain_issues=="unrelated"))
{
	$ChainissuesColor = "#ffcb1f"; #83bc00
}
else
{
	$ChainissuesColor = "#da002e";  // #83bc00
}


$smarty->assign('grade',$grade);
$smarty->assign('isTrusted',$isTrusted);
$smarty->assign('isTrusted_values',$isTrusted_values);
$smarty->assign('Chain_issues',$Chain_issues);
//colors of cases:
$smarty->assign('gradeColor',$gradeColor);
$smarty->assign('trustedColor',$trustedColor);
$smarty->assign('ChainissuesColor',$ChainissuesColor);
*/













/*
if($all_state == "OK")
{
//    echo "OK" ;
    exit_state("OK","it's OK",FALSE);
}
elseif($all_state == "WARNING")
{
//    echo "WARNING";
    exit_state("WARNING","it's WARNING",TRUE);
}
elseif($all_state == "CRITICAL")
{
//    echo "CRITICAL";
    exit_state("CRITICAL","it's CRITICAL",TRUE);
}
elseif($all_state == "UNKNOWN")
{
//    echo "UNKNOWN";
    exit_state("UNKNOWN","it's UNKNOWN",TRUE);
}
*/



?>
