<?php
/**
 * @name srv_control.php
 * @description Fichier principal du plugin serveur
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 09/11/2012
 */
$path = $_SERVER['DOCUMENT_ROOT'];
// $webp_name doit être identique au nom de la base de données !!!
$webp_name = 'website';

//$webp_model='model_'.$webp_name.'.php';
//Inclusion des librairie
include_once $path.'common.php';
include_once $path.'/Model_adm.php';

/*DESCRIPTION: inclus les variables habituelles pour la gestion d'un noeud et vérifie les droits d'accès
 *NECESSITE: la variable $webp_name configurée
 *           la variable $webp_model est incluste
 *APRES l'inclusion du common_node_control les variables suivantes sont créées:
 *PHP:
 *      $node objet de type device
 *      $template_path chemin d'accès vers le répertoire template du plugin (exemple: /usr/local/esia/public_html/plugin/server/templates/)
 *      $apache_plugin_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_info = array('id'=>$node->getId(),
					'name'=>$node->getName(),
					'ip'=>$node->getIPAddress(),
					'id'=>$node->getId(),
					'description'=>$node->getDescription(),
					'group'=>$node->getGroup());
 * SMARTY
		$webp_name nom du plugin
		$node avec les donnée de node_info (voir au dessus)
 *      $apache_path chemin apache du plugin (exemple: /plugin/server/)
 *      $node_status pour l'affichage commun des noeuds si $_GET['tab'] est vide
 *
 */
include_once $path.'/inc/common_node_control.php';

//Variable passé en paramètre
$tab='';
if(isset($_GET['tab'])&& !empty($_GET['tab']))
{
	$tab=$_GET['tab'];
}
$action='';
if(isset($_GET['action'])&& !empty($_GET['action']))
{
	$action=$_GET['action'];
}

$smarty->assign('tab', $tab);

$var = Model_esia::getServices($dbconnection,$_GET["nodeid"]);

// Le temps de réponse de http :
foreach ($var as $value)
{
	if($value['name'] == 'CHECK_HTTP')
	{
		$tmp_rep_http = $value['value']['http'];
		$services_state_http = $value['state'];
		break;
	}
}
// Le temps de réponse de dns :
foreach ($var as $value)
{
	if($value['name'] == 'CHECK_DNS')
	{
		$tmp_rep_dns = $value['value']['dns'];
		$services_state_dns = $value['state'];
		break;
	}
}
// certificate expire :
$services_state_certificat_exp = 3;
foreach ($var as $value)
{
	if($value['name'] == 'CHECK_HTTPS_CERTIFICATE_EXPIRE')
	{
		$certificat_exp = $value['stdout'];
		$services_state_certificat_exp = $value['state'];
		break;
	}
}

$certExpStateClass = "EventUnknown";
switch($services_state_certificat_exp)
{
	case 0:
		$certExpStateClass = "EventOK";
		break;
	case 1:
		$certExpStateClass = "EventWarning";
		break;
	case 2:
		$certExpStateClass = "EventCritical";
		break;
	default:
		$certExpStateClass = "EventUnknown";
}

$smarty->assign('services_state_http',$services_state_http);
$smarty->assign('services_state_dns',$services_state_dns);
$smarty->assign('services_state_certificat_exp',$services_state_certificat_exp);
$smarty->assign('certExpStateClass',$certExpStateClass);

$expires_in = $lang['WEBSITE_NO_EXP_DATE'];
// faire la regex pour chercher la date d'expiration dans le stdout de get service :
if(preg_match('#[a-zA-Z]+\s[a-zA-Z]+\s+[0-9]+\s[0-9\:]+\s[0-9]+\s\+[0-9]+#',$certificat_exp,$matches))
{
	//date :
	$time = strtotime($matches[0]);
	// $smarty->assign('certificate_expire',date('Y-m-d H:i:s', $time));
	// $smarty->assign('certificate_expire_sec',strtotime(date('Y-m-d H:i:s', $time)));

	$certificate_expire_sec = strtotime(date('Y-m-d H:i:s', $time)); 
	$today_sec=time();
	$certificate_expire_in=((($certificate_expire_sec-$today_sec)/60)/60)/24;
	$expires_in = round($certificate_expire_in,1) . " " . $lang['WEBSITE_EXP_DATE_ABBR'];
	// $expires_in = round((((strtotime(date('Y-m-d H:i:s', $time))-time())/60)/60)/24,1);
}
$smarty->assign('expires_in',$expires_in);


// extraire l'url pour l'intégrer dans l'iframe
$setting = Model_adm::getAdvanceNodeConfig($dbconnection,$_GET["nodeid"])[0];
$url_iframe = $setting['parameter']['type'];
$smarty->assign('url_iframe',$url_iframe);

// le découpage des url par parse_URL est différent si l'url commence par http/https ou pas 
if ($url_iframe[0].$url_iframe[1].$url_iframe[2].$url_iframe[3]=="http")
{
	$smarty->assign('url_host',parse_url($url_iframe, PHP_URL_HOST));
}
else {
	$smarty->assign('url_host',parse_url($url_iframe, PHP_URL_PATH));
}


//$homepage = file_get_contents('https://pagespeedonline.googleapis.com/pagespeedonline/v5/runPagespeed?url='.$url_iframe.'/&screenshot=true');
//$homepage = json_decode($homepage,true);
//$snap = $homepage['lighthouseResult']['audits']['full-page-screenshot']['details']['screenshot']['data'] ;

$smarty->assign('snap',$snap);
// echo "<img src=\"".$snap."\" />";


// echo <img src="data:image/jpeg;base64,/9j/$snap" />;
// print_r($googlepsdata) ;




//$webs_service = Model_esia::getServices($dbconnection,$node_id);


// // La condition sur les services (s'il existe déja ou pas)
// $service_CHECK_QUALYS = true;
// foreach ($var as $value )
// {
// 	if($value['name']== 'CHECK_QUALYS')
// 	{
// 		$service_CHECK_QUALYS =  false;
// 		$srvc_qualys_id = $value['id'];
// 	}
// }

// if($service_CHECK_QUALYS)
// {
// 	$plugin = Model_esia::getPlugin($dbconnection,'CHECK_QUALYS');
// 	$plugin = $plugin[0];
// 	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$url_iframe.'',$plugin['parameter']);
// 	Model_adm::addService($dbconnection,'CHECK_QUALYS',$plugin['id'],$_GET["nodeid"],300000,$url_param,2,null,null,null,null,null);
// }
// else
// {
// 	$plugin = Model_esia::getPlugin($dbconnection,'CHECK_QUALYS');
// 	$plugin = $plugin[0];
// 	$url_param = preg_replace('#^-u\s<url site web>#','-u '.$url_iframe.'',$plugin['parameter']);
// 	Model_adm::updateservice($dbconnection,$srvc_qualys_id,'CHECK_QUALYS',$plugin['id'],$_GET["nodeid"],300000,$url_param,2,null,null,null,null,null);
// }

//$adv_url = preg_replace('#^(http|https)://#','',$url_iframe);
$adv_url = preg_replace('#^(http|https)://(www\.)?#','',$url_iframe);

$url_iframe_tmp = explode('/',$adv_url);
$adv_url_beta = $url_iframe_tmp[0];

$result = fopen("/tmp/qualys/$adv_url_beta.txt","r");
$json =  fread($result, filesize("/tmp/qualys/$adv_url_beta.txt"));
$result = json_decode($json);
$result_data = json_decode($result->{'data'});

if(isset($result_data->{'grade'}) && isset($result_data->{'trusted'}) && isset($result_data->{'chain'}))
{
	$grade = $result_data->{'grade'};
	$isTrusted = $result_data->{'trusted'};
	$isTrusted_values = $result_data->{'trusted_value'};
	$Chain_issues = $result_data->{'chain'};
}
else
{
	$grade = $lang['WEBSITE_QUALYS_RUNNING'];
	$isTrusted = $lang['WEBSITE_QUALYS_RUNNING'];
	$Chain_issues = $lang['WEBSITE_QUALYS_RUNNING'];
// 	$grade = "en cours ...";
// 	$isTrusted = "en cours ...";
// 	$Chain_issues = "en cours ...";
}



// $homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
// $homepage = json_decode($homepage,true);

// $grade = $homepage[endpoints][0][grade];
// $trusted = $homepage[endpoints][0][details][certChains][0][trustPaths];
// // $B2 = $homepage[endpoints][0][details][certChains][0][trustPaths][0][trust][0][isTrusted];
// $Chain_issues = $homepage[endpoints][0][details][certChains][0][issues];

/*
$i= 0;
while(!isset($grade))
{
	$homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	$homepage = json_decode($homepage,true);
	
	$grade = $homepage[endpoints][0][grade];
	$i++;
}

$j =0 ;
while(!isset($trusted))
{
	$homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	$homepage = json_decode($homepage,true);
	
	$trusted = $homepage[endpoints][0][details][certChains][0][trustPaths];

	$j++;
}

$k =0;
while(!isset($Chain_issues))
{
	$homepage = file_get_contents('https://api.ssllabs.com/api/v3/analyze?host='.$url_iframe.'&all=on');
	$homepage = json_decode($homepage,true);
		// 	$B2 = $homepage[endpoints][0][details][certChains][0][trustPaths][0][trust][0][isTrusted];
	$Chain_issues = $homepage[endpoints][0][details][certChains][0][issues];
	$k++;
}
*/

// $count=0;
// $isTrusted = "No";
// foreach ($trusted as $value)
// {
// 	if($value[trust][0][isTrusted] != 0)
// 	{
// 		$isTrusted = "Yes";
// 		if($isTrusted_values[$count-1]!=$value[trust][0][rootStore])
// 		{
// 			$isTrusted_values[$count] = $value[trust][0][rootStore];
// 			$count++;
// 		}
// 	}
// }

// $tmp = $isTrusted_values;
// $c = $isTrusted_values[0];
// for ($i = 1; $i <= count($isTrusted_values)-1; $i++) {
// 	$c=$c."-".$isTrusted_values[$i];
// }
// $isTrusted_values = $c;

// switch($Chain_issues)
// {
// 	case 0:
// 		$Chain_issues = "None";
// 		break;
// 	case 2:
// 		$Chain_issues = "incomplete";
// 		break;
// 	case 4:
// 		$Chain_issues = "unrelated";
// 		break;
// 	case 8:
// 		$Chain_issues = "order incorrect";
// 		break;
// 	case 16:
// 		$Chain_issues = "self-signed";
// 		break;
// 	case 32:
// 		$Chain_issues = "not validate";
// 		break;
// }

// colors :

if(($grade=="A") || ($grade=="A+") || ($grade=="A-") || ($grade==$lang['WEBSITE_QUALYS_RUNNING'] ))
{
	$gradeColor = "#83bc00";
}
elseif(($grade=="B") || ($grade=="C"))
{
	$gradeColor = "#ffcb1f";
}
else
{
	$gradeColor = "#da002e";
}

if($isTrusted=="Yes" || ($isTrusted==$lang['WEBSITE_QUALYS_RUNNING'] ))
{
	$trustedColor = "#83bc00";
}
else
{
	$trustedColor = "#da002e";
}

if($isTrusted==$lang['WEBSITE_QUALYS_RUNNING'] )
{
	$ChainissuesColor = "#83bc00";
}
elseif($Chain_issues=="None")
{
	$ChainissuesColor = "#222222";
}
elseif (($Chain_issues=="incomplete") || ($Chain_issues=="unrelated"))
{
	$ChainissuesColor = "#ffcb1f"; #83bc00
}
else
{
	$ChainissuesColor = "#da002e";  // #83bc00
}


$smarty->assign('grade',$grade);
$smarty->assign('isTrusted',$isTrusted);
$smarty->assign('isTrusted_values',$isTrusted_values);
$smarty->assign('Chain_issues',$Chain_issues);
//colors of cases:
$smarty->assign('gradeColor',$gradeColor);
$smarty->assign('trustedColor',$trustedColor);
$smarty->assign('ChainissuesColor',$ChainissuesColor);


$smarty->assign('tmp_rep_http',$tmp_rep_http);
$smarty->assign('tmp_rep_dns',$tmp_rep_dns);

session_write_close();
try
{
    if($tab=='servicestate')
    {
    }
}
//Traitement des exceptions SNMP et des erreurs de traitement dans la base de donnée
catch(DeviceNotAliveException $e)
{
	$smarty->assign('errors','no');
}
catch(DeviceSNMPException $e)
{
	$smarty->assign('errors',$lang['ADM_ERR_SNMP_FAILED']);
}
catch(DeviceException $e)
{
	$smarty->assign('errors',$e->getMessage());
}


$smarty->display($template_path.'control_'.$webp_name.'.html');
?>
